#!/usr/bin/perl
#use strict;
################################################################################
# eNews                                             Version 1.0.2              #
# Copyright 1999 Frederic TYNDIUK (FTLS)            All Rights Reserved.       #
# E-Mail: tyndiuk@ftls.org                          Script License: GPL        #
# Created  12/31/99                                 Last Modified 01/12/2000   #
# Scripts Archive at:                               http://www.ftls.org/cgi/   #
################################################################################
# Function :  Multi 'news of the day' system                                   #
################################################################################
################################################################################
# Necessary Variables:                                                         #
# The following variables should be set to define the locations                #
# and URLs of various files, as explained in the documentation.                #

require 'cgi-lib.pl';

my $DATA_DIR            = '/Absolute/path/to/data_dir/enews/';
my $TEMPLATE_DIR        = $DATA_DIR;
my $WEB_DIR			    = '/Absolute/path/to/web_dir/news/';
my $NEWS_CATEGORY_FILE  = 'category.txt';
my $NEWS_MODERATOR_FILE = 'moderator.txt';

my $WEBMASTER_EMAIL = 'webmaster@ftls.org';

my $DISPLAY_LANG = 'Fr';

my $UNIV_LOGIN    = '';
my $UNIV_PASSWORD = '';

# Nothing Below this line needs to be altered!                                 #
################################################################################
#    DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING    #
################################################################################
my $VALUE_GENERATOR = 'eNew v1.0 made by FTLS (TYNDIUK Frederic, htp://www.ftls.org/)';
my $VALUE_DCREATION = &ConvDate('', '%D');

my $ADMINISTER_QUERY = 'admin';
my $MODERATE_QUERY  = 'moder';

my(%NAME_HEADTAB, %NAME_BUTTON, %NAME_TITLE, @WEEK_DAYS, @MONTHS, %input);

if ($DISPLAY_LANG eq 'Fr') {
	%NAME_HEADTAB = ('login' => 'Login', 'password' => 'Mot de passe', 'confpass' => 'Confirmer le mot de passe',
		'CategName' => 'Nom cat&eacute;gorie', 'Moderator' => 'Mod&eacute;rateur', 'NbSubmitNews' => 'Nouvelles soumises', 'NbValidNews' => 'Nouvelles valides',
		'NewsTitle' => 'Titre', 'NewsAuthorName' => 'Nom auteur', 'NewsAuthorEMail' => 'E-Mail', 'NewsText' => 'Texte',
		'ModerPerm' => 'Droits', 'ModerPseudo' => 'Pseudo', 'ModerName' => 'Nom', 'ModerEMail' => 'E-Mail',
		'FormCategTitle' => 'Titre cat&eacute;gorie', 'FormCategIdent' => 'Indentifiant', 'FormCategModerLogin' => 'Login(s) moderateur(s)',
		'FormCategFData' => 'Nom fichier donn&eacute;es', 'FormCategFNew' => 'Nom fichier news', 'FormCategFWeb' => 'Nom fichier web r&eacute;sultat', 'FormCategFTpre' => 'Nom fichier template de pr&eacute;sentation', 
		'FormCategFTnew' => 'Nom fichier template presentation des nouvelles', 'FormCategFTadd' => 'Nom fichier Template d\'ajout'
		);
	%NAME_BUTTON  = ('Moderate' => 'Moderer', 'Validate' => 'Validater', 'Add' => 'Ajouter', 'Edit' => 'Editer', 'Suppress' => 'Supprimer', 'SeeValid' => 'Voir valides', 'SeeNotValid' => 'Voir NON valides',
		'Ok' => 'Ok', 'Back' => 'Retour', 'Enter' => 'Entrer', 'Cancel' => 'Abandonner', 'Exit' => 'Sortir',
		'Admin' => 'Administrateur', 'Moder' => 'Moderateur',
		'MkHTMLAll'=> 'Gnrer ces pages HTML', 'AdminModer' => 'Administrer les moderateurs');
	%NAME_TITLE = ('CommonModer'  => 'eNews, &eacute;cran mod&eacute;ration', 'CommonModerCateg' => "eNews, &eacute;cran mod&eacute;ration de 'Value_Categ' Value_Stats",
		'CommonAdmin'  => "eNews, &eacute;cran d'administration", 'CommonAdminCateg' => "eNews, &eacute;cran d'administration de cat&eacute;gorie",  'CommonAdminModer' => "eNews, &eacute;cran d'administration des mod&eacute;rateurs",
		'ModerNewsSup' => "Nouvelle 'Value_Title' supprimm&eacute;e", 'ModerNewsSaved' => "Nouvelle 'Value_Title' sauv&eacute;e", 'ModerNewsAdded' => "Nouvelle 'Value_Title' ajout&eacute;e", 'ModerNewsValid' => "Nouvelle 'Value_Title' valid&eacute;e", 'ModerNewsValidStats' => 'valides', 'ModerNewsNotValidStats' => 'nouvellement soumises', 'ModerNewsEdit' => "Editer la nouvelle 'Value_Title'", 'ModerNewsAdd' => "Ajouter une nouvelle", 'ModerHTMLGenerator' => 'G&eacute;n&eacute;rateur des pages web',
		'AdminCategAdd'=> "Ajout d'une nouvelle categorie", 'AdminCategEdit' => "Editer la cat&eacute;gorie 'Value_Title'" , 'AdminCategAdded' => "Categorie 'Value_Title' ajout&eacute;e", 'AdminCategSup' => "Categorie 'Value_Title' supprimm&eacute;e", 'AdminCategSaved' => "Categorie 'Value_Title' sauv&eacute;e",
		'AdminModerAdd'=> "Ajout d'un nouveau mod&eacute;rateur" , 'AdminModerEdit' => "Editer le mod&eacute;rateur 'Value_Title'", 'AdminModerAdded' => "Mod&eacute;rateur 'Value_Title' ajout&eacute;", 'AdminModerSup' => "Mod&eacute;rateur 'Value_Title' supprimm&eacute;", 'AdminModerSaved' => "Mod&eacute;rateur 'Value_Title' sauv&eacute;",
		'PublicNewsSaved' => "Nouvelle 'Value_Title' enregist&eacute;e", 'PublicNewsError' => "Nouvelle 'Value_Title' incomplette", 'PublicNewsNot' => 'Pas ne nouvelles...',
		'ErrorBadForm' => 'Erreur formulaire incomplet', 'Login' => 'Entrer votre mot de passe', 'InvPass' => 'MOT de PASSE INCORRECT');
	@WEEK_DAYS = ('Dimanche', 'Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi', 'Samedi');
	@MONTHS    = ('Janvier','F&eacute;vrier','Mars','Avril','Mai','Juin','Juillet','Ao&ucirc;t','Septembre','Octobre','Novembre','D&eacute;cembre');
} else {
	%NAME_HEADTAB = ('login' => 'Login', 'password' => 'Password', 'confpass' => 'Confirme password',
		'CategName' => 'Category Name', 'Moderator' => 'Moderator', 'NbSubmitNews' => 'Submited News', 'NbValidNews' => 'Valide News',
		'NewsTitle' => 'Title', 'NewsAuthorName' => 'Author Name', 'NewsAuthorEMail' => 'E-Mail', 'NewsText' => 'Text',
		'ModerPerm' => 'Level', 'ModerPseudo' => 'Pseudo', 'ModerName' => 'Name', 'ModerEMail' => 'E-Mail',
		'FormCategTitle' => 'Category Title', 'FormCategIdent' => 'Indentifiant', 'FormCategModerLogin' => 'Login(s) moderator(s)',
		'FormCategFData' => 'File data Name', 'FormCategFNew' => 'File new name', 'FormCategFWeb' => 'Result web file name', 'FormCategFTpre' => 'Template page present file name', 
		'FormCategFTnew' => 'Template news present file name', 'FormCategFTadd' => 'Template add file name'
		);
	%NAME_BUTTON  = ('Moderate' => 'Moderate', 'Validate' => 'Validate', 'Add' => 'Add', 'Edit' => 'Edit', 'Suppress' => 'Remove', 'SeeValid' => 'See valide', 'SeeNotValid' => 'See NOT Valide',
		'Ok' => 'Ok', 'Back' => 'Back', 'Enter' => 'Enter', 'Cancel' => 'Cancel', 'Exit' => 'Exit', 
		'Admin' => 'Administrator', 'Moder' => 'Moderator',
		'MkHTMLAll'=> 'Generate these HTML pages', 'AdminModer' => 'Administer moderator');
	%NAME_TITLE = ('CommonModer'  => 'eNews, moderate display', 'CommonModerCateg' => "eNews, moderate 'Value_Categ' Value_Stats display", 
		'CommonAdmin'  => 'eNews, administrative display', 'CommonAdminCateg' => "eNews, category administrative display",  'CommonAdminModer' => "eNews, moderator administrative display",
		'ModerNewsSup' => "News 'Value_Title' suppressed", 'ModerNewsSaved' => "News 'Value_Title' saved", 'ModerNewsAdded' => "News 'Value_Title' added", 'ModerNewsValid' => "News 'Value_Title' Validated", 'ModerNewsValidStats' => 'validate', 'ModerNewsNotValidStats' => 'new submited', 'ModerNewsEdit' => "Edit news 'Value_Title'", 'ModerNewsAdd' => "Add a news", 'ModerHTMLGenerator' => 'Web pages generator',
		'AdminCategAdd'=> "Add new category", 'AdminCategEdit' => "Edit 'Value_Title' category", 'AdminCategAdded' => "Category 'Value_Title' added", 'AdminCategSup' => "Category 'Value_Title' suppressed", 'AdminCategSaved' => "Category 'Value_Title' saved",
		'AdminModerAdd'=> "Add new moderator", 'AdminModerEdit'=> "Edit 'Value_Title' moderator", 'AdminModerAdded' => "Moderator 'Value_Title' added", 'AdminModerSup' => "Moderator 'Value_Title' suppressed", 'AdminModerSaved' => "Moderator 'Value_Title' saved",
		'PublicNewsSaved' => "News 'Value_Title' submited", 'PublicNewsError' => "News 'Value_Title' not complete", 'PublicNewsNot' => 'No News',
		'ErrorBadForm' => 'Error Incomplet data form', 'Login' => 'Enter your Password', 'InvPass' => 'INVALID PASSWORD');
	@WEEK_DAYS = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	@MONTHS    = ('January','February','March','April','May','June','July','August','September','October','November','December');
}

	&ReadParse(\%input);

	if ($input{'BT_Exit'}) { print "Location: /\n\n"; exit; }
	print &PrintHeader;

	my $Login = $input{'login'};
	my $Password = $input{'pass'};
	my $Action = $input{'ac'};
	my $NoSend = $input{'no'};
	my $Id = $input{'id'};

	my @category_data_file = &Read_Data_File($DATA_DIR.$NEWS_CATEGORY_FILE);

	if ($input{'BT_moderate'} && (! $Id) && ($NoSend ne '')) {
		$Action = $MODERATE_QUERY;
		($Id) = split /\t/, $category_data_file[$NoSend];
	}

	if ($Id) {
		($_) = grep /^$Id\t/, @category_data_file;
	} else {
		($_) = grep ! /^\s*#/, @category_data_file;
	}
	my($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title) = split /\t|\n/;
	my $default_id = $id;
	$NAME_TITLE{'CommonModerCateg'} =~ s/Value_Categ/$categ_title/ig;

	my($ModeratorLevel, $ModeratorName, $ModeratorMail);
	if (($Action =~ /$MODERATE_QUERY/) || ($Action eq $ADMINISTER_QUERY)) {
		if (! $Login && ! $Password) {
			print &PagePassword();
			exit;
		} else {
			($ModeratorLevel, $ModeratorName, $ModeratorMail) =  &check_password($Login, $Password)
		}
	}

	my($date, $title, $text, $author_name, $author_mail);
	my($mlogin, $mpass, $mperm, $mname, $mpseudo, $memail);
	my($i, $no, $txt, $good, $mid, $mlo, $result, $file, @tmp, @moderator_list);

################################################################################
# Moderator Display                                                            #
################################################################################

	if ($Action =~ /$MODERATE_QUERY/) {
		if (($ModeratorLevel ne 'moderator') && ($ModeratorLevel ne 'root')) {
			&BadPassword($NAME_TITLE{'CommonModer'});
		}
		$good = 0;
		# Only good login...
		if ($ModeratorLevel ne 'root') {
			@tmp = @category_data_file;
			@category_data_file = ();
			foreach (@tmp) {
				if (! /#/) {
					($mid, $mlo) = split(/\t|\n/, $_);
					foreach $b (split(/\s*,\s*/, $mlo)) {
						if ($b eq $Login) {
							push(@category_data_file, $_);
						}
					}
				}
			}
		}

		if ($input{'BT_MakeHTML'}) {
			&MakeHTML("$NAME_TITLE{'CommonModer'}<BR>$NAME_TITLE{'ModerHTMLGenerator'}", \@category_data_file);
		}

		if ($input{'BT_moderate_back'}) { $Id = ''; }

		if ($Id) {
			if (! grep /^$Id\t/, @category_data_file) {
				&BadPassword($NAME_TITLE{'CommonModer'});
			}

			if ($input{'BT_moderate_see_not_valid_news'}) { $Action = $MODERATE_QUERY.'_new'; }
			if ($input{'BT_moderate_see_valid_news'})     { $Action = $MODERATE_QUERY.'_data'; }

			if ($Action eq $MODERATE_QUERY.'_data') {
				$file = $DATA_DIR.$file_data;
				$NAME_TITLE{'CommonModerCateg'} =~ s/Value_Stats/$NAME_TITLE{'ModerNewsValidStats'}/gi;
			} else {
				$file = $DATA_DIR.$file_new;
				$NAME_TITLE{'CommonModerCateg'} =~ s/Value_Stats/$NAME_TITLE{'ModerNewsNotValidStats'}/gi;
			}

			if ($input{'BT_moderate_add_news'}) {
				&AddEdit(0, $file, $Action, $Id, $NoSend, $Login, $Password, $categ_title);
			}

			if ($input{'BT_moderate_edit_news'} && ($NoSend ne '')) {
				&AddEdit(1, $file, $Action, $Id, $NoSend, $Login, $Password, $categ_title);
			}


			if ($input{'BT_moderate_validate_news'} && ($NoSend ne '')) {
				@tmp = &Read_Data_File($DATA_DIR.$file_new);
				&Write_Data_2_End_File($DATA_DIR.$file_data, $tmp[$NoSend]);

				($date, $title) = split /\t/, $tmp[$NoSend];
			   	splice(@tmp, $NoSend, 1);
				&Write_Data_2_File($DATA_DIR.$file_new, \@tmp);

				$NAME_TITLE{'ModerNewsValid'} =~ s/Value_Title/$title/gi;
				print &Return_Admin_Result_Page("$NAME_TITLE{'CommonModerCateg'}<BR>$NAME_TITLE{'ModerNewsValid'}", $Id, $Action, $Login, $Password, 'BT_moderate', $NAME_BUTTON{'Back'});
			    exit;	
			}

			if ($input{'BT_moderate_sv_add_edit'}) {
				if ($input{'title'} && $input{'text'}) {
					$input{'text'} =~ s/\n+$//g;
					$input{'text'} =~ s/\n+/<BR>/g;
					$input{'text'} =~ s/\t+//g;

					@tmp = &Read_Data_File($file);
					$result = "$input{'date'}\t$input{'title'}\t$input{'text'}\t$input{'author_name'}\t$input{'author_mail'}\n";

					if ($NoSend >= 0) { #if Not New
					    $tmp[$NoSend] = $result;
					    $txt = $NAME_TITLE{'ModerNewsSaved'};
					} else {
						push(@tmp, $result);
				    	$txt = $NAME_TITLE{'ModerNewsAdded'};
					}
					&Write_Data_2_File($file, \@tmp);
				} else {
					$txt = $NAME_TITLE{'ErrorBadForm'};
				}
					$txt =~ s/Value_Title/$input{'title'}/gi;
					print &Return_Admin_Result_Page("$NAME_TITLE{'CommonModerCateg'}<BR>$txt", $Id, $Action, $Login, $Password, 'BT_moderate', $NAME_BUTTON{'Back'});
			 	    exit;	
			}

			if ($input{'BT_moderate_suppress_news'} && ($NoSend >= 0)) {
				@tmp = &Read_Data_File($file);
				($date, $title) = split /\t/, $tmp[$NoSend];
			   	splice(@tmp, $NoSend, 1);
				&Write_Data_2_File($file, \@tmp);

				$NAME_TITLE{'ModerNewsSup'} =~ s/Value_Title/$title/gi;
				print &Return_Admin_Result_Page("$NAME_TITLE{'CommonModerCateg'}<BR>$NAME_TITLE{'ModerNewsSup'}", $Id, $Action, $Login, $Password, 'BT_moderate', $NAME_BUTTON{'Back'});
			    exit;	
			}

			my($add_valid, $go_valid);
			print &HTMLHeaderTitle($NAME_TITLE{'CommonModerCateg'});
			$i = @tmp = &Read_Data_File($file);
			$no = 0; $txt = '';
    		print "<FORM METHOD=post><TABLE Border=0 WIDTH=\"80%\" ALIGN=\"CENTER\">\n";
			foreach (@tmp) {
				($date, $title, $text, $author_name, $author_mail) = split /\t|\n/;
				$txt  = &ModerPresentNews($i, $no, $title, &ConvDate($date, '%d %B %Y %H:%M'), $text, $author_name, $author_mail).$txt;
				$i--; $no++;
			}
			print $txt."</TABLE>\n";
			print &Hidden_HTML_Login_Infos($Id, $Action, $Login, $Password);
			if ($Action eq $MODERATE_QUERY."_data") {
				$go_valid  = "<INPUT TYPE=Submit Value=\" $NAME_BUTTON{'SeeNotValid'} \" NAME=BT_moderate_see_not_valid_news>";
				$add_valid = "<INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Add'} \" NAME=BT_moderate_add_news>";
			} else {
				$add_valid = "<INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Validate'} \" NAME=BT_moderate_validate_news>";
				$go_valid  = "<INPUT TYPE=Submit Value=\" $NAME_BUTTON{'SeeValid'} \" NAME=BT_moderate_see_valid_news>";
			}

		    print "<P><CENTER>\n $add_valid <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Edit'} \" NAME=BT_moderate_edit_news> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Suppress'} \" NAME=BT_moderate_suppress_news> $go_valid <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Back'} \" NAME=BT_moderate_back>\n</CENTER></FORM>\n";
			print &HTMLEnd;
	    	exit;	
		}

		&Print_Moderate_Display($Action, $Login, $Password, $ModeratorLevel, \@category_data_file);
	}


################################################################################
# Administrative Display                                                       #
################################################################################

	if ($Action eq $ADMINISTER_QUERY) {
		if ($ModeratorLevel ne 'root') {
			&BadPassword($NAME_TITLE{'CommonAdmin'});
		}

########################################
# Moderator Administrative Display     #
########################################

		if ($input{'BT_add_moderator'}) {
			&Add_Edit_Moderator(0, $Action, $Id, '-1', $Login, $Password);
		}


		if ($input{'BT_edit_moderator'} && ($NoSend ne '')) {
			&Add_Edit_Moderator(1, $Action, $Id, $NoSend, $Login, $Password);
		}


		if ($input{'BT_sv_add_edit_moderator'}) {
			if ($input{'mlogin'} && ($input{'mpass'} eq $input{'cmpass'}) && $input{'mname'}) {
				$result = "$input{'mlogin'}\t$input{'mpass'}\t$input{'mperm'}\t$input{'mname'}\t$input{'mpseudo'}\t$input{'memail'}\n";
				@moderator_list = &Read_Data_File($DATA_DIR.$NEWS_MODERATOR_FILE);

				if ($NoSend >= 0) { #if Not New
				    $moderator_list[$NoSend] = $result;
			    	$txt = $NAME_TITLE{'AdminModerSaved'};
				} else {
					push(@moderator_list, $result);
				    $txt = $NAME_TITLE{'AdminModerAdded'};
				}
				&Write_Data_2_File($DATA_DIR.$NEWS_MODERATOR_FILE, \@moderator_list);
				$txt =~ s/Value_Title/$input{'mname'}/gi;
			} else {
				$txt = $NAME_TITLE{'ErrorBadForm'};
			}
			print &Return_Admin_Result_Page("$NAME_TITLE{'CommonAdminModer'}<BR>$txt", $Id, $Action, $Login, $Password, 'BT_adm_moderator', $NAME_BUTTON{'Back'});
			exit;
		}

		if ($input{'BT_suppress_moderator'} && ($NoSend ne '')) {
			@moderator_list = &Read_Data_File($DATA_DIR.$NEWS_MODERATOR_FILE);
			($mlogin, $mpass, $mperm, $mname, $mpseudo, $memail) = split /\t|\n/, $moderator_list[$NoSend];
		   	splice(@moderator_list, $NoSend, 1);
			&Write_Data_2_File($DATA_DIR.$NEWS_MODERATOR_FILE, \@moderator_list);
			$NAME_TITLE{'AdminModerSup'} =~ s/Value_Title/$mname/gi;
			print &Return_Admin_Result_Page("$NAME_TITLE{'CommonAdminModer'}<BR>$NAME_TITLE{'AdminModerSup'}", $Id, $Action, $Login, $Password, 'BT_adm_moderator', $NAME_BUTTON{'Back'});
		    exit;	
		}

		if ($input{'BT_adm_moderator'} || $input{'BT_suppress_moderator'} || $input{'BT_edit_moderator'}) {
			@moderator_list = &Read_Data_File($DATA_DIR.$NEWS_MODERATOR_FILE);
			print &HTMLHeaderTitle($NAME_TITLE{'CommonAdminModer'});
    		print "<FORM METHOD=post><INPUT TYPE=HIDDEN Value=$input{'ac'} NAME=ac><INPUT TYPE=HIDDEN Value=$input{'login'} NAME=login><INPUT TYPE=HIDDEN Value=$input{'pass'} NAME=pass>\n";
	    	print "<TABLE Border=0 WIDTH=\"80%\" ALIGN=\"CENTER\"><TR><TD COLSPAN=2>\n";
			print "<TABLE BGCOLOR=\"navy\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"1\" WIDTH=\"100%\"><TR><TD>\n";
			print "<TABLE BGCOLOR=\"#DCDCDC\" BORDER=\"0\" CELLSPACING=\"1\" CELLPADDING=\"3\" WIDTH=\"100%\">\n";
			print "<TR><TD> &nbsp;</TD><TH> $NAME_HEADTAB{'login'} </TH><TH> $NAME_HEADTAB{'ModerPerm'} </TH><TH> $NAME_HEADTAB{'ModerPseudo'} </TH><TH> $NAME_HEADTAB{'ModerName'} </TH><TH> $NAME_HEADTAB{'ModerEMail'} </TH></TR>\n";
			$no = 0;
			foreach (@moderator_list) {
				if (! /#/) {
					($mlogin, $mpass, $mperm, $mname, $mpseudo, $memail) = split(/\t|\n/, $_);
					$memail = "<A HREF=\"mailto:$memail\">$memail</A>";
					if (! $mpseudo) { $mpseudo = "&nbsp;"; }
					if ($mperm eq 'root') { $mperm = $NAME_BUTTON{'Admin'}; }
					if ($mperm eq 'moderator') { $mperm = $NAME_BUTTON{'Moder'} }
					print "<TR><TD><INPUT TYPE=radio Name='no' Value='$no'></TD><TD>$mlogin</TD><TD>$mperm</TD><TD>$mpseudo</TD><TD>$mname</TD><TD>$memail</TD></TR>\n";
				}
				$no++;
			}
			print "</TABLE></TD></TR></TABLE>\n";
			print "<CENTER><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Add'} \" NAME=BT_add_moderator> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Edit'} \" NAME=BT_edit_moderator> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Suppress'} \" NAME=BT_suppress_moderator></CENTER>\n";
			print "</TD></TR></TABLE>\n";
		   	print "<CENTER><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Back'} \"></CENTER>\n";
			print "</FORM>\n";
	    	print &HTMLEnd;
    		exit;
	    }

########################################
# Category BT Administrative Display   #
########################################

		if ($input{'BT_MakeHTML'}) {
			&MakeHTML("$NAME_TITLE{'CommonAdmin'}<BR>$NAME_TITLE{'ModerHTMLGenerator'}", \@category_data_file);
		}

		if ($input{'BT_add_category'}) {
			&Add_Edit_Category(0, $Action, $Id, '-1', $Login, $Password);
		}


		if ($input{'BT_edit_category'} && ($NoSend ne '')) {
				&Add_Edit_Category(1, $Action, $Id, $NoSend, $Login, $Password);
		}


		if ($input{'BT_sv_add_edit_category'}) {
			if ($input{'sid'} && $input{'categ_title'}) {
				$input{'sid'} =~ s/[^\w]//g;
				$result = "$input{'sid'}\t$input{'moderator'}\t".$input{'sid'}."_data.txt\t".$input{'sid'}."_new.txt\t$input{'file_web'}\t$input{'file_tpl_pres'}\t$input{'file_tpl_news'}\t$input{'file_tpl_add'}\t$input{'categ_title'}\n";
				if ($NoSend >= 0) { #if Not New
			    	$category_data_file[$NoSend] = $result;
			    	$txt = $NAME_TITLE{'AdminCategSaved'};
				} else {
					push(@category_data_file, $result);
			    	$txt = $NAME_TITLE{'AdminCategAdded'};
				}
				$txt =~ s/Value_Title/$input{'categ_title'}/;
				&Write_Data_2_File($DATA_DIR.$NEWS_CATEGORY_FILE, \@category_data_file);
			} else {
				$txt = $NAME_TITLE{'ErrorBadForm'};
			}
			print &Return_Admin_Result_Page("$NAME_TITLE{'CommonAdminCateg'}<BR>$txt", $Id, $Action, $Login, $Password, 'BT_admin_categ', $NAME_BUTTON{'Back'});
			exit;
		}

		if ($input{'BT_suppress_category'} && ($NoSend ne '')) {
			($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title) =  split /\t|\n/, $category_data_file[$NoSend];
	   		splice(@category_data_file, $NoSend, 1);
			&Write_Data_2_File($DATA_DIR.$NEWS_CATEGORY_FILE, \@category_data_file);
			$NAME_TITLE{'AdminCategSup'} =~ s/Value_Title/$categ_title/gi;
			print &Return_Admin_Result_Page("$NAME_TITLE{'CommonAdminCateg'}<BR>$NAME_TITLE{'AdminCategSup'}", $Id, $Action, $Login, $Password, 'BT_admin_categ', $NAME_BUTTON{'Back'});
		    exit;	
		}

########################################
# Common Administrative Display        #
########################################

		&Print_Moderate_Display($ADMINISTER_QUERY, $Login, $Password, $ModeratorLevel, \@category_data_file);
	}


################################################################################
# Public Display                                                               #
################################################################################

	if ($input{'PublicVisu'}) {
		$result = &Return_template_add_form($TEMPLATE_DIR.$file_tpl_add, $input{'title'}, $input{'text'}, $input{'author_name'}, $input{'author_mail'});
		$input{'text'} =~ s/\n+$//g;
		$input{'text'} =~ s/\n+/<BR>/g;
		$input{'text'} =~ s/\t+//g;

		$_ = time."\t$input{'title'}\t$input{'text'}\t$input{'author_name'}\t$input{'author_mail'}\n";
		print &Return_HTML_news_present($id, $file_tpl_pres, $file_tpl_news, $categ_title, $result, ($_));

	} elsif ($input{'PublicSubmit'}) {
		if ($input{'title'} && $input{'text'}) {
			$input{'text'} =~ s/\n+$//g;
			$input{'text'} =~ s/\n+/<BR>/g;
			$input{'text'} =~ s/\t+//g;
			$input{'date'} = time;
			if ($input{'author_name'} !~ /\w/) { $input{'author_name'} = 'Anonymous'; }

			$result = "$input{'date'}\t$input{'title'}\t$input{'text'}\t$input{'author_name'}\t$input{'author_mail'}\n";
			&Write_Data_2_End_File($DATA_DIR.$file_new, $result);
			$txt = $NAME_TITLE{'PublicNewsSaved'};
		} else {
			$txt = $NAME_TITLE{'PublicNewsError'};
		}
		$txt =~ s/Value_Title/$input{'title'}/gi;
		print &Return_HTML_news_present($id, $file_tpl_pres, $file_tpl_news, $categ_title, &Title($txt), ($result));

	} elsif (($Action eq 'add') && ($Id)) {
		$result = &Return_template_add_form($TEMPLATE_DIR.$file_tpl_add, '', '', '', '');
		print &Return_HTML_news_present($id, $file_tpl_pres, $file_tpl_news, $categ_title, $result, ());

	} else {
		$Id = $default_id;
		@tmp = &Read_Data_File($DATA_DIR.$file_data);
		print &Return_HTML_news_present($Id, $file_tpl_pres, $file_tpl_news, $categ_title, '', @tmp);
	}

################################################################################
# Subs                                                                         #
################################################################################
sub Print_Moderate_Display {
	my($action, $login, $password, $moderatorlevel, $pt_category_data_file) = @_;
	my($select, $list_text_moderator, $nb_news_data, $nb_news_new);
	my($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title);
		if ($moderatorlevel eq 'root') {
			$title = $NAME_TITLE{'CommonAdmin'};
			$action = $ADMINISTER_QUERY;
		} else {
			$title = $NAME_TITLE{'CommonModer'};
		}
		print &HTMLHeaderTitle($title);
		@moderator_list = &Read_Data_File($DATA_DIR.$NEWS_MODERATOR_FILE);

	    print "<FORM METHOD=post><INPUT TYPE=HIDDEN Value=$action NAME=ac><INPUT TYPE=HIDDEN Value=$login NAME=login><INPUT TYPE=HIDDEN Value=$password NAME=pass>\n";
    	print "<TABLE Border=0 WIDTH=\"80%\" ALIGN=\"CENTER\"><TR><TD COLSPAN=2>\n";
		print "<TABLE BGCOLOR=\"navy\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"1\" WIDTH=\"100%\"><TR><TD>\n";
		print "<TABLE BGCOLOR=\"#DCDCDC\" BORDER=\"0\" CELLSPACING=\"1\" CELLPADDING=\"3\" WIDTH=\"100%\">\n";
		print "<TR><TD> &nbsp;</TD><TH> $NAME_HEADTAB{'CategName'} </TH><TH> $NAME_HEADTAB{'Moderator'} </TH><TH> $NAME_HEADTAB{'NbSubmitNews'} </TH><TH> $NAME_HEADTAB{'NbValidNews'} </TH></TR>\n";
		$no = 0;
		foreach (@$pt_category_data_file) {
			if (! /#/) {
				$list_text_moderator = '';
				($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title) = split(/\t|\n/, $_);
				foreach $b (split(/\s*,\s*/, $modlogin)) {
					if (($_) = grep(/^$b\t/, @moderator_list)) {
						($mlogin, $mpass, $mperm, $mname, $mpseudo, $memail) = split(/\t|\n/, $_);
						if ($mpseudo) { $mname = $mpseudo; }
						$list_text_moderator .= "<A HREF=\"mailto:$memail\">$mname</A> ";
					}
				}
				$nb_news_data = &Count_Not_Empty_Line($DATA_DIR.$file_data);
				$nb_news_new  = &Count_Not_Empty_Line($DATA_DIR.$file_new);
				if (! $list_text_moderator) { $list_text_moderator = "&nbsp;"; }
				if ($moderatorlevel eq "root") {
					$select = "<INPUT TYPE=radio Name='no' Value='$no'>";
				} else {
					$select = "<INPUT TYPE=radio Name=\"id\" Value=\"$id\">";
				}
				print "<TR><TD>$select</TD><TD>$categ_title</TD><TD>$list_text_moderator</TD><TD ALIGN=\"CENTER\">$nb_news_new</TD><TD ALIGN=\"CENTER\">$nb_news_data</TD></TR>\n";
			}
			$no++;
		}
		print "</TABLE></TD></TR></TABLE>\n";
		print "<CENTER> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Moderate'} \" NAME=BT_moderate>\n";
		if ($moderatorlevel eq "root") {
			print "&nbsp; &nbsp; &nbsp; <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Add'} \" NAME=BT_add_category> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Edit'} \" NAME=BT_edit_category> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Suppress'} \" NAME=BT_suppress_category>\n";
		}
		print "</CENTER><BR><BR></TD></TR>\n";
		print "<TR><TD WIDTH=\"50%\"><FONT SIZE=\"-1\" FACE=\"Arial\"><INPUT TYPE=Submit Value=\" >> \" NAME=BT_MakeHTML> $NAME_BUTTON{'MkHTMLAll'}</FONT></TD><TD>\n";
		if ($moderatorlevel eq "root") {
			print "<FONT SIZE=\"-1\" FACE=\"Arial\"><INPUT TYPE=Submit Value=\" >> \" NAME=BT_adm_moderator> $NAME_BUTTON{'AdminModer'}</FONT>\n";
		}
		print "</TD></TR></TABLE>\n";
   		print "<CENTER><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Exit'} \" NAME=\"BT_Exit\"></CENTER>\n";
		print "</FORM>\n";
    	print &HTMLEnd;
    	exit;
}

sub AddEdit {
	my($edit, $file, $action, $id, $noline, $login, $password, $categ_title) = @_;
	my($page_title, $date, $title, $text, $author_name, $author_mail);
	if ($edit) {
		open(EDITFILE, "$file") || print "Cannot open data file $file, error: $!\n";
		$_ = (<EDITFILE>)[$noline];
		close(EDITFILE);
		($date, $title, $text, $author_name, $author_mail) = split /\t|\n/;
		$page_title = $NAME_TITLE{'ModerNewsEdit'};
		$page_title =~ s/Value_Title/$title/gi;
		$text =~ s/<BR>/\n/gi;
	} else {
		$page_title = $NAME_TITLE{'ModerNewsAdd'};
		$date = time;
		$noline = -1;
		$author_name = $ModeratorName;
		$author_mail = $ModeratorMail;
	}
    print  &HTMLHeaderTitle("$NAME_TITLE{'CommonModerCateg'}<BR>$page_title");
	print "<FORM METHOD=post><CENTER>\n";
	print "<INPUT Name=no TYPE=HIDDEN Value=\"$noline\"><INPUT Name=date TYPE=HIDDEN Value=\"$date\">\n";
	print "<TABLE BGCOLOR=\"navy\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"1\" WIDTH=\"70%\"><TR><TD>";
	print "<TABLE BGCOLOR=\"#DCDCDC\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"3\" WIDTH=\"100%\">\n";
	print "<TR><TD>$NAME_HEADTAB{'NewsTitle'} : </TD><TD><INPUT NAME=title TYPE=Text Size=20 Value=\"$title\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'NewsAuthorName'} : </TD><TD> <INPUT Name=author_name TYPE=Text SIZE=20 Value=\"$author_name\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'NewsAuthorEMail'} : </TD><TD> <INPUT Name=author_mail TYPE=Text SIZE=20 Value=\"$author_mail\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'NewsText'} : </TD><TD> <TEXTAREA Name=text COLS=50 ROWS=5>$text</TEXTAREA></TD></TR>\n";
	print "</TABLE></TD></TR></TABLE><P><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Ok'} \" NAME=BT_moderate_sv_add_edit> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Cancel'} \" NAME=ok></CENTER>\n";
	print &Hidden_HTML_Login_Infos($id, $action, $login, $password) , "</FORM>\n";
	print &HTMLEnd;
	exit;
}


sub Add_Edit_Category {
	my($edit, $action, $id, $noline, $login, $password) = @_;
	my($page_title, $moderator, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title);
	if ($edit) {
		($id, $moderator, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title) = split /\t|\n/, $category_data_file[$noline];
		$page_title = $NAME_TITLE{'AdminCategEdit'};
		$page_title =~ s/Value_Title/$categ_title/gi;
	} else {
		$page_title = $NAME_TITLE{'AdminCategAdd'};
		$noline = '-1';
	}
    print  &HTMLHeaderTitle($NAME_TITLE{'CommonAdminCateg'}.'<BR>'.$page_title);
	print "<FORM METHOD=post><CENTER>\n";
	print "<INPUT Name=no TYPE=HIDDEN Value=\"$noline\">\n";
	print "<TABLE BGCOLOR=\"navy\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"1\" WIDTH=\"70%\"><TR><TD>\n";
	print "<TABLE BGCOLOR=\"#DCDCDC\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"3\" WIDTH=\"100%\">\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategTitle'} : </TD><TD><INPUT Name=no TYPE=HIDDEN Value=\"$noline\"><INPUT Name=categ_title TYPE=Text SIZE=20 Value=\"$categ_title\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategIdent'} : </TD><TD><INPUT NAME=sid TYPE=Text Size=10 Value=\"$id\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategModerLogin'} : </TD><TD><INPUT Name=moderator TYPE=Text SIZE=20 Value=\"$moderator\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategFWeb'} : </TD><TD><INPUT Name=file_web TYPE=Text SIZE=20 Value=\"$file_web\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategFTpre'} : </TD><TD><INPUT Name=file_tpl_pres TYPE=Text SIZE=20 Value=\"$file_tpl_pres\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategFTnew'} : </TD><TD><INPUT Name=file_tpl_news TYPE=Text SIZE=20 Value=\"$file_tpl_news\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'FormCategFTadd'} : </TD><TD><INPUT Name=file_tpl_add TYPE=Text SIZE=20 Value=\"$file_tpl_add\"></TD></TR>\n";
    print "</TABLE></TD></TR></TABLE><P><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Ok'} \" NAME=BT_sv_add_edit_category> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Cancel'} \"></CENTER>\n";
	print &Hidden_HTML_Login_Infos($id, $action, $login, $password) , "</FORM>\n";
	print &HTMLEnd;
	exit;
}

sub Add_Edit_Moderator {
	my($edit, $action, $id, $noline, $login, $password) = @_;
	my($page_title, $mlogin, $mpass, $mperm, $mname, $mpseudo, $memail, $perm_selec1, $perm_selec2);
	if ($edit) {
		@moderator_list = &Read_Data_File($DATA_DIR.$NEWS_MODERATOR_FILE);
		($mlogin, $mpass, $mperm, $mname, $mpseudo, $memail) = split /\t|\n/, $moderator_list[$noline];
		$page_title = $NAME_TITLE{'AdminModerEdit'};
		$page_title =~ s/Value_Title/$mname/gi;
		if ($mperm eq 'root') { $perm_selec2 = 'SELECTED'; } else { $perm_selec1 = 'SELECTED'; }
	} else {
		$page_title = $NAME_TITLE{'AdminModerAdd'};
		$noline = '-1';
		$perm_selec1 = 'SELECTED'; $perm_selec1 = '';
	}
    print  &HTMLHeaderTitle($NAME_TITLE{'CommonAdminModer'}.'<BR>'.$page_title);
	print "<FORM METHOD=post><CENTER>\n";
	print "<INPUT Name=no TYPE=HIDDEN Value=\"$noline\">\n";
	print "<TABLE BGCOLOR=\"navy\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"1\" WIDTH=\"70%\"><TR><TD>\n";
	print "<TABLE BGCOLOR=\"#DCDCDC\" BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"3\" WIDTH=\"100%\">\n";
	print "<TR><TD>$NAME_HEADTAB{'ModerName'} : </TD><TD><INPUT Name=no TYPE=HIDDEN Value=\"$noline\"><INPUT Name=mname TYPE=Text SIZE=20 Value=\"$mname\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'ModerPseudo'} : </TD><TD><INPUT Name=mpseudo TYPE=Text SIZE=20 Value=\"$mpseudo\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'ModerEMail'} : </TD><TD><INPUT NAME=memail TYPE=Text Size=20 Value=\"$memail\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'login'} : </TD><TD><INPUT NAME=mlogin TYPE=Text Size=10 Value=\"$mlogin\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'password'} : </TD><TD><INPUT Name=mpass TYPE=password SIZE=10 Value=\"$mpass\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'confpass'} : </TD><TD><INPUT Name=cmpass TYPE=password SIZE=10 Value=\"$mpass\"></TD></TR>\n";
	print "<TR><TD>$NAME_HEADTAB{'ModerPerm'} : </TD><TD><SELECT NAME=\"mperm\"><OPTION $perm_selec1 VALUE=\"moderator\">$NAME_BUTTON{'Moder'} <OPTION $perm_selec2 VALUE=\"root\">$NAME_BUTTON{'Admin'} </SELECT></TD></TR>\n";
    print "</TABLE></TD></TR></TABLE><P><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Ok'} \" NAME=BT_sv_add_edit_moderator> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Cancel'} \" NAME=\"BT_adm_moderator\"></CENTER>\n";
	print &Hidden_HTML_Login_Infos($id, $action, $login, $password) , "</FORM>\n";
	print &HTMLEnd;
	exit;
}

sub MakeHTML {
	my($title, $pt_category_data_file) = @_;
	my(@file_data, $tpl_press, $tpl_news, $result, $date, $text, $author_name, $author_mail);
	my($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title);

	print &HTMLHeaderTitle($title);
	foreach (@$pt_category_data_file) {
		if (! /^\s*#/) {
			($id, $modlogin, $file_data, $file_new, $file_web, $file_tpl_pres, $file_tpl_news, $file_tpl_add, $categ_title) = split /\t|\n/;
			print "Make $categ_title<BR>";
			@file_data = &Read_Data_File($DATA_DIR.$file_data);
			$tpl_press = &Return_HTML_news_present($id, $file_tpl_pres, $file_tpl_news, $categ_title, '', @file_data);
			open(FILE, ">$WEB_DIR$file_web") || print "Cannot write file $WEB_DIR$file_web, error: $!<BR>\n";
			print FILE $tpl_press;
			close(FILE);
		}
	}
	print &Back($Id, $Action, $Login, $Password, 'BT_moderate_back', $NAME_BUTTON{'Back'});
	print &HTMLEnd;
	exit;
}

sub Return_HTML_news_present {
	my($id, $file_tpl_pres, $file_tpl_news, $categ_title, $result_text, @file_data) = @_;
	my($tpl_press, $tpl_news, $result, $date, $title, $text, $author, $author_name, $author_mail);

	$tpl_press = join '', &Read_Data_File($TEMPLATE_DIR.$file_tpl_pres);
	$tpl_news  = join '', &Read_Data_File($TEMPLATE_DIR.$file_tpl_news);

	$result = '';
	foreach (reverse @file_data) {
		if (! /^\s*#/) {
			($date, $title, $text, $author_name, $author_mail) = split /\t|\n/;
			$date = &ConvDate($date, '%d %B %Y %H:%M');
			$_ = $tpl_news;
			s/Value_date/$date/ig;
			s/Value_title/$title/ig;
			s/Value_text/$text/ig;
			if ($author_mail =~ /@/) {
				$author = "<A HREF=\"mailto:$author_mail\">$author_name</A>";
			} else {
				$author = $author_name;
			}
			s/Value_author/$author/ig;
			$result .= $_;
		}
	}

	if (! $result && ! $result_text) { $result = "<CENTER><B>$NAME_TITLE{'PublicNewsNot'}</B></CENTER><BR>"; }
	$tpl_press =~ s/Value_News/$result$result_text/ig;
	$tpl_press =~ s/Value_CategoryTitle/$categ_title/ig;
	$tpl_press =~ s/Value_DCreation/$VALUE_DCREATION/ig;
	$tpl_press =~ s/Value_Generator/$VALUE_GENERATOR/ig;
	$tpl_press =~ s/Value_Author/$VALUE_GENERATOR/ig;
	$tpl_press =~ s/Value_ID/$id/ig;

	return $tpl_press;
}

sub Return_template_add_form {
	my($file_template_add, $value_title, $value_text, $value_author_name, $value_author_mail) = @_;
	$_ = join '', &Read_Data_File($file_template_add);

	s/Value_title/$value_title/ig;
	s/Value_text/$value_text/ig;
	s/Value_author_name/$value_author_name/ig;
	s/Value_author_mail/$value_author_mail/ig;
	return $_;
}

sub Count_Not_Empty_Line {
	my($file) = @_;
	my $nb_line = 0;
	if ( -e $file) {
		open(FILE, "<$file") || print "Cannot open file $file to count line, error: $!\n";
		while(<FILE>) { if ($_) { $nb_line++; } }
		close(FILE);
	}
	return $nb_line;
}

sub Write_Data_2_File {
	my($file, $pt_arry_data) = @_;
	open(OUT, ">$file") || print "Cannot write file $file, error: $!<BR>\n";
	print OUT @$pt_arry_data;
	close(OUT);
}

sub Write_Data_2_End_File {
	my($file, $line) = @_;
	open(OUTEND, ">>$file") || print "Cannot write file $file, error: $!<BR>\n";
	print OUTEND $line;
	close(OUTEND);
}

sub Read_Data_File {
	my($file) = @_;
	my @data;
	open(IN, "$file") || print "Cannot open file $file, error: $!<BR>\n";
	@data = <IN>;
	close(IN);
	return @data;
}

sub check_password {
	my($login, $password) = @_;
	my($flogin, $fpass, $flevel, $fname, $fpseudo, $fmail);

	if ($login && $password && ($login eq $UNIV_LOGIN) && ($password eq $UNIV_PASSWORD)) { return 'root'; }
	
	if ($login && $password) {
		open(PASSWORD, "$DATA_DIR$NEWS_MODERATOR_FILE");
	 	($_) = grep(/^$login\t/, <PASSWORD>);
	  	close(PASSWORD);
		($flogin, $fpass, $flevel, $fname, $fpseudo, $fmail) = split /\t|\n/;

		if (($flogin eq $login) && ($fpass eq $password))  {
			if ($fpseudo) { $fname = $fpseudo; }
	    	 return ($flevel, $fname, $fmail);
		}
	}
	return 0;
}


sub Hidden_HTML_Login_Infos {
	my($id, $ac, $login, $password) = @_;
	$_  = "\n<INPUT TYPE=HIDDEN Value=$id NAME=id>\n";
	$_ .= "<INPUT TYPE=HIDDEN Value=$ac NAME=ac>\n";
	$_ .= "<INPUT TYPE=HIDDEN Value=$login NAME=login>\n";
	$_ .= "<INPUT TYPE=HIDDEN Value=$password NAME=pass>\n";
	return $_;
}

sub Return_Admin_Result_Page {
	my($pagetitle, $id, $ac, $login, $password, $bt_name, $bt_title) = @_;
	my($txt);
	$txt  = &HTMLHeader($pagetitle).&Title($pagetitle);
	$txt .= &Back($Id, $Action, $Login, $Password, $bt_name, $bt_title);
	return  $txt.&HTMLEnd;
}

sub ModerPresentNews {
	my($i, $no, $title, $date, $text, $author_name, $author_mail) = @_;
	if ($author_mail =~ /\@/) { $author_name = "<A HREF=\"mailto:$author_mail\">$author_name</A>" }
return <<EOF;
<TR><TD>$i<INPUT TYPE=Radio NAME=no Value=$no></TD><TD>
<TABLE ALIGN="CENTER" BGCOLOR="navy" BORDER="0" CELLSPACING="0" CELLPADDING="1" WIDTH="100%"><TR><TD>
<TABLE BGCOLOR="#DCDCDC" BORDER="0" CELLSPACING="0" CELLPADDING="3" WIDTH="100%">
<TR><TD BGCOLOR="#336699"><FONT SIZE="-1" FACE="Arial" COLOR="white"><B>$title</B> ($date), $author_name</FONT></TD></TR>
<TR></TD><TD><FONT SIZE="-1" FACE="Arial">$text</FONT></TD></TR>
</TABLE></TD></TR></TABLE>
</TD></TR>\n
EOF
}

sub PagePassword {
	my($title, $ac_code);
    if ($input{'ac'}) {
    	if ($input{'ac'} eq $ADMINISTER_QUERY) { $title = $NAME_TITLE{'CommonAdmin'}; } else { $title = $NAME_TITLE{'CommonModer'}; }
    	$ac_code = "<INPUT TYPE=\"HIDDEN\" NAME=\"ac\" VALUE=\"$input{'ac'}\">"; 
	} else {
    	$ac_code = "<SELECT NAME=\"ac\"><OPTION VALUE=\"$ADMINISTER_QUERY\">$NAME_BUTTON{'Admin'}<OPTION VALUE=\"$MODERATE_QUERY\">$NAME_BUTTON{'Moder'}</SELECT>";
    }
    $_ = &HTMLHeaderTitle($title."<BR>".$NAME_TITLE{'Login'});
	$_ .= <<EOF;
	<TABLE ALIGN="CENTER" BGCOLOR="navy" BORDER="0" CELLSPACING="0" CELLPADDING="1" WIDTH="50%"><TR><TD>
	<TABLE BGCOLOR="#DCDCDC" BORDER="0" CELLSPACING="0" CELLPADDING="3" WIDTH="100%"><TR><TD>
	<FORM METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="id" VALUE="$input{'id'}">
	<TABLE BORDER="0" WIDTH="100%" CELLSPACING="10" CELLPADDING="1">
	<TR><TD>$NAME_HEADTAB{'login'} :</TD><TD><INPUT TYPE=text NAME=login SIZE="10"></TD>
	<TD>$ac_code</TD></TR>
	<TR><TD>$NAME_HEADTAB{'password'} :</TD><TD><INPUT TYPE="Password" NAME="pass" SIZE="10"></TD>
	<TD><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'Enter'} \"></TD></TR></TABLE>
	</FORM>
	</TD></TR></TABLE>
	</TD></TR></TABLE>
	<TD></TD></TR>
EOF
    return $_.&HTMLEnd;
}

sub BadPassword {
    print &HTMLHeaderTitle($_[0]);
    print "<CENTER><BR><BR><B><FONT FACE=\"Arial\" SIZE=\"+3\">$NAME_TITLE{'InvPass'}</FONT></B><BR><BR><BR>\n";
    print &HTMLEnd;
	exit;
}

sub HTMLHeaderTitle {
	return &HTMLHeader($_[0]).&Title($_[0]);
}

sub HTMLHeader {
	my($head_title) = @_;
	$head_title =~ s/\<\w\w*\>/ /gi;
    return <<EOF;
<HTML><HEAD><TITLE>$head_title</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<META NAME="ROBOTS" CONTENT="NOINDEX, FOLLOW">
<META NAME="description" content="none">
<META NAME="keywords" content="none">
<META NAME="Author" CONTENT="$VALUE_GENERATOR">
<META NAME="GENERATOR" CONTENT="$VALUE_GENERATOR"></HEAD>
<BODY BGCOLOR="#FFFFFF">
EOF
}

sub Title {
    return <<EOF;
<BR><BR><P ALIGN="Center"><FONT FACE="Arial, helvetica" SIZE="+2" COLOR="#336699"><STRONG><EM>$_[0]</EM></STRONG></FONT></P><BR>
EOF
}

sub Back {
    my($id, $action, $login, $password, $bt_name, $bt_txt) = @_ ;
	if (! $txt) { $txt = $NAME_BUTTON{'Back'}; }
	if (! $bt_name) { $bt_name = 'ok' }
   	return  "<CENTER>\n<FORM METHOD=POST>".&Hidden_HTML_Login_Infos($id, $action, $login, $password)."<INPUT TYPE=Submit Value=\"$bt_txt\" NAME=$bt_name></FORM>\n</CENTER>\n";
}

sub HTMLEnd {
	# En : Don't change or remove this Copyright.
	# Fr : Ne modifiez pas ni ne supprimez ce Copyright.
    return "<CENTER><BR><BR><FONT FACE=\"Arial\" SIZE=\"-2\">
<EM>&copy Copyright 2000 <A HREF=\"http://www.ftls.org/\">FTLS</A> (Tyndiuk Fr&eacute;d&eacute;ric). All rights reserved.
<BR>FTLS's CGI Scripts Archives : <A HREF=\"http://www.ftls.org/cgi/\">http://www.ftls.org/cgi/</A>.
<BR>Send all comments to <A HREF=\"mailto:$WEBMASTER_EMAIL\">$WEBMASTER_EMAIL</A></EM>.
</FONT></CENTER></BODY></HTML>";
}

sub ConvDate {
	my($time, $format) = @_;
	if (! $time)   { $time = time; }
	if (! $format) { $format = '%D' }
	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($time);
	my $full_en_text_date = localtime($time);
	$mon++;
	my $yearl = $year + 1900;
	if ($year > 99) { $year -= 100; }
	my ($short_mon) = substr($MONTHS[$mon-1],  0, 3);
	my ($short_wday) = substr($WEEK_DAYS[$wday], 0, 3);
	my $mdayl = sprintf('%02d', $mday);
	my $monl  = sprintf('%02d', $mon);
	$sec   = sprintf('%02d', $sec);
	$min   = sprintf('%02d', $min);
	$hour  = sprintf('%02d', $hour);
	$year  = sprintf('%02d', $year);

	$_ = $format;
	s/%%/%/g;
	s/%a/$short_wday/g;
	s/%A/$WEEK_DAYS[$wday]/g;
	s/%b|%h/$short_mon/g;
	s/%B/$MONTHS[$mon-1]/g;
	s/%c/$full_en_text_date/g;
	s/%d/$mdayl/g;
	s/%D|%x/$monl\/$mday\/$year/g;
	s/%e/$mday/g;
	s/%m/$monl/g;
	s/%H/$hour/g;
	s/%j/$yday/g;
	s/%M/$min/g;
	s/%S/$sec/g;
	s/%n/\n/g;
	s/%t/\t/g;
	s/%X|%T/$hour:$min:$sec/g;
	s/%y/$year/g;
	s/%Y/$yearl/g;
	return $_;
}
